package com.qmth.distributed.print.business.service.impl;

import com.qmth.distributed.print.business.bean.dto.open.PaperConfig;
import com.qmth.distributed.print.business.bean.dto.open.PaperStructure;
import com.qmth.distributed.print.business.entity.GradeBatchPaper;
import com.qmth.distributed.print.business.service.GradeBatchPaperService;
import com.qmth.distributed.print.business.service.GradePaperService;
import com.qmth.distributed.print.business.service.GradePaperStructService;
import com.qmth.distributed.print.business.service.OpenApiService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;

@Service
public class OpenApiServiceImpl implements OpenApiService {

    @Resource
    private GradeBatchPaperService gradeBatchPaperService;

    @Resource
    private GradePaperService gradePaperService;

    @Resource
    private GradePaperStructService gradePaperStructService;

    @Override
    public PaperConfig getPaperConfig(String thirdExamId, String gradeCourseCode) {
        GradeBatchPaper gradeBatchPaper = gradeBatchPaperService.findByThirdExamIdAndGradeCourseCode(thirdExamId, gradeCourseCode);
        if (gradeBatchPaper == null) {
            return null;
        }
        return gradePaperService.findBySchoolIdAndPaperNumberAndPaperType(gradeBatchPaper.getSchoolId(), gradeBatchPaper.getPaperNumber(), gradeBatchPaper.getPaperType());
    }

    @Override
    public PaperStructure getPaperStructure(String thirdExamId, String gradeCourseCode) {
        GradeBatchPaper gradeBatchPaper = gradeBatchPaperService.findByThirdExamIdAndGradeCourseCode(thirdExamId, gradeCourseCode);
        if (gradeBatchPaper == null) {
            return null;
        }

        return gradePaperStructService.findBySchoolIdAndPaperNumberAndPaperType(gradeBatchPaper.getSchoolId(), gradeBatchPaper.getPaperNumber(), gradeBatchPaper.getPaperType());
    }
}
